
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de datos: 'YouTube2012'
--

-- --------------------------------------------------------

--
-- Estructura de tabla 'video_asset' (cada asset puede tener varios items - mismo video en diferentes calidades o codificaciones)
--

DROP TABLE IF EXISTS `video_asset`;
CREATE TABLE IF NOT EXISTS `video_asset` (
  video_asset_id int(10) NOT NULL auto_increment,
  video_name varchar(255) character set utf8 collate utf8_unicode_ci NOT NULL,
  video_date datetime DEFAULT NULL,
  video_views int(10) NOT NULL default '0',
  processed tinyint(1) NOT NULL default '0',
  regdate datetime NOT NULL,
  PRIMARY KEY  (video_asset_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


INSERT INTO `video_asset` (`video_asset_id`, `video_name`, `video_views`, `processed`, `regdate`) VALUES
(1, '1DJOTEDBA2c', 0, 0, '0000-00-00 00:00:00');


-- --------------------------------------------------------

--
-- Estructura de tabla 'video_item' (item dentro de un video asset)
--

DROP TABLE IF EXISTS `video_item`;
CREATE TABLE IF NOT EXISTS `video_item` (
  video_item_id int(10) unsigned NOT NULL auto_increment,
  video_asset_id int(10) unsigned NOT NULL default '0',
  video_url varchar(255) character set utf8 collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (video_item_id),
  KEY asset_id (video_asset_id)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla 'video_item_info'
--

DROP TABLE IF EXISTS `video_item_info`;
CREATE TABLE IF NOT EXISTS `video_item_info` (
  `video_item_id` int(10) unsigned NOT NULL,
  `muxer` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `bitrate` int(10) NOT NULL,
  `size` int(10) NOT NULL,
  `duration` int(10) NOT NULL,
  `is_video_active` tinyint(1) NOT NULL DEFAULT '0',
  `is_audio_active` tinyint(1) NOT NULL DEFAULT '0',
  `video_codec` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `video_width` int(10) NOT NULL DEFAULT '0',
  `video_height` int(10) NOT NULL DEFAULT '0',
  `video_duration` int(10) NOT NULL DEFAULT '0',
  `video_bitrate` int(10) NOT NULL DEFAULT '0',
  `audio_codec` varchar(20) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `audio_duration` int(10) NOT NULL DEFAULT '0',
  `audio_bitrate` int(10) NOT NULL DEFAULT '0',
  `raw_data` longtext CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  PRIMARY KEY (`video_item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


