<?php

function get_next_active_video()  //get_next_active_dir
{
    global $dbc;

    $sql = 'SELECT video_asset_id,
                   video_name
            FROM video_asset
            WHERE processed = 0
            ORDER BY regdate
            LIMIT 1';

    $result = mysql_query($sql, $dbc);
    if ( mysql_num_rows($result) == 0 )
    {
        $new_active_video['id']      =  0;
        $new_active_video['name']    =  'root';
        $new_active_video['path']    =  BASE_DIR . 'root';
        $new_active_video['webpath'] =  '';
    }
    else
    {
        list($video_id, $name) = mysql_fetch_row($result);

        $new_active_video['id']      =  $video_id;
        $new_active_video['name']    =  $name;
        $new_active_video['path']    =  BASE_DIR . $name;
        $new_active_video['webpath'] =  'watch?v=' . $name;

        $sql = 'UPDATE video_asset 
                SET processed = 1
                WHERE video_asset_id = '. $video_id;

        mysql_query($sql, $dbc);        
    }

    return $new_active_video;
}


function unescape_UTF8_Seq( $str )
{
    return preg_replace_callback("/\\\u([0-9a-f]{4})/i",
        create_function('$matches',
            'return html_entity_decode(\'&#x\'.$matches[1].\';\', ENT_QUOTES, \'UTF-8\');'
        ), $str );
}


function parse_youtube_webpage( $filepath )
{
    // Get video page content
    $subject = file_get_contents( $filepath );

    // Find video URLS
    $pattern = '|playerConfig = (.*)};|U';
    preg_match_all  ( $pattern, $subject, $matches );

    $matches_info = $matches[1][0] . '}';
    $player_info  = json_decode( $matches_info );

    $player_args  = $player_info->args;
    $urls_encoded = $player_args->url_encoded_fmt_stream_map;
    $all_urls     = explode( ',', $urls_encoded );

    // Decode and process URLs
    $video_item_list = array();
    foreach ( $all_urls as $url )
    {
        $url_decoded = urldecode( urldecode($url) );
        $video_url = substr_replace( $url_decoded, '', 0, 4 );
        $video_url = unescape_UTF8_Seq( $video_url );

        /// Remove parameters "itag" and "type" at the end of the URL!!!
        /// Otherwise the URL is not valid (don't know why)
        $pos = strrpos( $video_url, "&type=" );
        if ( $pos !== FALSE && $pos > 0 && $pos < strlen( $video_url ) )
        {
            $video_url = substr( $video_url, 0, $pos );
        }
        else 
        {
            $pos = strrpos( $video_url, "&itag=" );
            if ( $pos !== FALSE && $pos > 0 && $pos < strlen( $video_url ) )
                $video_url = substr( $video_url, 0, $pos );
        }

        $video_item_list[] = $video_url;
    }

    // Get view count
    unset($matches);
    $subject = file_get_contents( $filepath );
    $pattern = '|<strong>(.*)</strong>|U';
    preg_match_all( $pattern, $subject, $matches);

    $views = $matches[1][0];
    $views = str_replace(',', '', $views );
    $views = (int)$views;

    // Get date
    unset($matches);
    $subject = file_get_contents( $filepath );
    $pattern = '|watch-video-date(.*)</span>|U';
    preg_match_all( $pattern, $subject, $matches );

    $date = $matches[1][0];
    $date = str_replace( '" >', '', $date );
    $time = strtotime( $date );
    $date = date( 'Y-m-d H:i:s', $time );

    // Create result
    $result['video_item_list'] = $video_item_list;
    $result['views']           = $views;
    $result['datetime']        = $date;

    return $result;
}


function get_video_name_from_url( $url )
{
    $url_info = parse_url($url);

    $aux_arr = explode( '&', $url_info['query'] );
    foreach ( $aux_arr as $pair )
    {
        $pair_arr = explode( '=', $pair );
        if ( $pair_arr[0] == 'v' )
            return $pair_arr[1];
    }

    return '';
}


function insert_video( $video_name, $video_views, $video_date )
{
    global $dbc;

    $sql = 'SELECT video_asset_id
            FROM video_asset
            WHERE name = "'. addslashes($video_name) .'"';

    $result = mysql_query($sql, $dbc);
    if ( $result !== FALSE && mysql_num_rows($result) )
        return false;

    $sql = 'INSERT INTO video_asset
            SET video_name  = "'. addslashes($video_name) .'",
                video_views = "'. $video_views .'",
                video_date = "'. $video_date .'",
                regdate     = NOW()';

    mysql_query($sql, $dbc);
    $video_id = mysql_insert_id($dbc);

    return $video_id;
}


function insert_video_item( $video_asset_id, $url )
{
    global $dbc;

    $sql = 'INSERT INTO video_item
            SET video_asset_id = "'. $video_asset_id .'",
                video_url      = "'. addslashes( $url ) .'"';

    mysql_query($sql, $dbc);
    $video_item_id = mysql_insert_id( $dbc );

    return $video_item_id;
}


function insert_video_item_info( $item_id, $props )
{
    global $dbc;

    $insert_clauses     = array();
    $insert_clauses_sql = '';
    
    $data = json_decode( $props );

    if ( isset( $data->muxer ) )
    {
        $insert_clauses[] = ' muxer = "'. addslashes( $data->muxer->format_name ) .'" ';
        $insert_clauses[] = ' bitrate = "'. intval( $data->muxer->bit_rate ) .'" ';
        $insert_clauses[] = ' duration = "'. intval( $data->muxer->duration ) .'" ';
        $insert_clauses[] = ' size = "'. intval( $data->muxer->size ) .'" ';
    }

    $video_info = NULL;
    $audio_info = NULL;

    if ( isset( $data->streams ) )
    {
        if ( count( $data->streams ) > 0 )
        {
            if ( $data->streams[0]->codec_type == 'video' )
                $video_info = $data->streams[0];
            else if ( $data->streams[0]->codec_type == 'audio' )
                $audio_info = $data->streams[0];
        }
        if ( count( $data->streams ) > 1 )
        {
            if ( $data->streams[1]->codec_type == 'video' )
                $video_info = $data->streams[1];
            else if ( $data->streams[1]->codec_type == 'audio' )
                $audio_info = $data->streams[1];
        }
    }

    if ( $video_info != NULL )
    {
        $insert_clauses[] = ' is_video_active = "1" ';
        $insert_clauses[] = ' video_codec = "'. addslashes( $video_info->codec_name ) .'" ';
        $insert_clauses[] = ' video_width = "'. intval( $video_info->width ) .'" ';
        $insert_clauses[] = ' video_height = "'. intval( $video_info->height ) .'" ';
        $insert_clauses[] = ' video_duration = "'. intval( $video_info->duration ) .'" ';
        $insert_clauses[] = ' video_bitrate = "'. intval( $video_info->bitrate ) .'" ';
    }
    if ( $audio_info != NULL )
    {
        $insert_clauses[] = ' is_audio_active = "1" ';
        $insert_clauses[] = ' audio_codec = "'. addslashes( $audio_info->codec_name ) .'" ';
        $insert_clauses[] = ' audio_duration = "'. intval( $audio_info->duration ) .'" ';
        $insert_clauses[] = ' audio_bitrate = "'. intval( $audio_info->bitrate ) .'" ';
    }

    $insert_clauses[] = ' raw_data = "'. addslashes($props) .'" ';

    if ( count($insert_clauses) )
        $insert_clauses_sql = ',' . implode(',', $insert_clauses);

    
    $sql = 'INSERT INTO video_item_info
            SET video_item_id = "'. $item_id .'"
                '. $insert_clauses_sql;

    mysql_query($sql, $dbc);
}


function update_video_views( $video_name, $video_views )
{
    global $dbc;

    $sql = 'UPDATE video_asset
            SET video_views = "'. $video_views .'"
            WHERE video_name = "'. $video_name .'"';

    mysql_query($sql, $dbc);
}

function update_video_date( $video_name, $video_datetime )
{
    global $dbc;

    $sql = 'UPDATE video_asset
            SET video_date = "'. $video_datetime .'"
            WHERE video_name = "'. $video_name .'"';

    mysql_query($sql, $dbc);
}


?>